Ruby/redmine_invoice_rate/config/routes.rb
# Plugin's routes
# See: http://guides.rubyonrails.org/routing.html
resources :project_billings

get 'project_invoice', :to => 'project_invoice#new'

Ruby/redmine_invoice_rate/app/models/project_billing.rb
class ProjectBilling < ActiveRecord::Base
	unloadable

	has_many :project_user_prices
	belongs_to	:project, :class_name => "Project", :foreign_key => "project_id"
end

Ruby/redmine_invoice_rate/app/models/project_user_price.rb
class ProjectUserPrice < ActiveRecord::Base
  unloadable

  belongs_to :project_billing 
  belongs_to :user, :class_name => "User", :foreign_key => "user_id"

  delegate :billing, :to => :project_billing

  def self.get_user_on_project user_id, project_billing_id
  	self.where("user_id = ? and project_billing_id = ?", user_id, project_billing_id).first
  end
  
end

Ruby/redmine_invoice_rate/app/controllers/project_billings_controller.rb
class ProjectBillingsController < ApplicationController
  unloadable

  before_filter :auth_index, :only => [:index]

  before_filter :set_project_billing, only: [:show, :edit, :update, :destroy]

  before_filter :auth_edit, :only => [:show, :edit, :update, :destroy]

  before_filter :find_project_by_project_id, :only => [:index, :new, :create]
  # GET /project_billings
  # GET /project_billings.json
  def index
    @project_billings = ProjectBilling.find_by_project_id @project.id
  end

  # GET /project_billings/1
  # GET /project_billings/1.json
  def show
  end

  # GET /project_billings/new
  def new
    if @project.users.length > 0
      @project_billing = ProjectBilling.new
      @project_billing.project = @project
      @project.users.each do |user|
        user_price = ProjectUserPrice.new(:user => user, :price => 0)
        @project_billing.project_user_prices << user_price
      end
    else
      flash[:notice] = "No users on the project"
      redirect_to_home
    end
  end

  # GET /project_billings/1/edit
  def edit
  end

  # POST /project_billings
  # POST /project_billings.json
  def create
    @project_billing = ProjectBilling.new
    @project_billing.project = @project
    project_billing_params.each do |user_id, price|
      user_price = ProjectUserPrice.new(:user => User.find(user_id), :price => price || 0.0)
      if user_price.save
        @project_billing.project_user_prices << user_price
      end
    end
    if @project_billing.save
      flash[:notice] = "save succeful"
      redirect_to_home
    else
      flash[:notice] = "save failed"
    end
  end

  # PATCH/PUT /project_billings/1
  # PATCH/PUT /project_billings/1.json
  def update
    project_billing_params.each do |user_id, price|
      if user = ProjectUserPrice.get_user_on_project(user_id, @project_billing.id)
        unless user.price == price
          if user.update_attributes(:price => price)
            flash[:notice] = "save succeful"
          else
            flash[:notice] = "save failed "
          end
        end
      else
        user_price = ProjectUserPrice.new(:user => User.find(user_id), :price => price || 0.0)
        if user_price.save
          @project_billing.project_user_prices << user_price
        end
      end
    end
    if @project_billing.save
      redirect_to_home
    end 
  end

  # DELETE /project_billings/1
  # DELETE /project_billings/1.json
  def destroy
    @project_billing.destroy
    respond_to do |format|
      format.html { redirect_to project_billings_url, notice: 'Project billing was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private

    def auth_index
      unless @project
        @project = Project.find(params[:project_id])
      end
      check_permission @project   
    end

    def auth_edit
      if @project_billing
        check_permission @project_billing.project
      else
        render_404
      end
    end

    def check_permission project
      if !User.current.allowed_to?(:redmine_invoice_rate, project)
        render_404
      end
    end

    def redirect_to_home
      redirect_to project_billings_path(:project_id => @project_billing.project.identifier)
    end

    # Use callbacks to share common setup or constraints between actions.
    def set_project_billing
      @project_billing = ProjectBilling.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def project_billing_params
      params[:project_billing]
    end
end

Ruby/redmine_invoice_rate/app/controllers/project_invoice_controller.rb
class ProjectInvoiceController < ApplicationController
  unloadable

  before_filter :auth, :only => [ :new ]

  before_filter :find_project_by_project_id, :only => [ :new ]

  def new

    @invoice = Invoice.new
    @invoice.number = Invoice.generate_invoice_number(@project)
    @invoice.invoice_date = Date.today
    @invoice.contact = Contact.find_by_id(params[:contact_id]) if params[:contact_id]
    @invoice.assigned_to = User.current
    @invoice.currency ||= ContactsSetting.default_currency
    # Custom for context_menu action
    if params[:issues_ids]
      @invoice.amount = 0.0;
      scope = Issue.scoped(:include => :time_entries,  :conditions => {:id => params[:issues_ids]})
      scope.all.each do |issue|
        if user = ProjectBilling.find_by_project_id( @project.id ).project_user_prices.find_by_user_id( issue.assigned_to_id )
          price = user.price
        end

        @invoice.lines << InvoiceLine.new(
          :description  => issue.subject, 
          :quantity     => issue.spent_hours || 0.0 , 
          :price        => price || 0.0,
          :units        => issue.spent_hours == 1.0 ? 'hr' : 'hrs',
        )
        @invoice.amount += price*issue.spent_hours
      end

    end
    #EndCustom
    @invoice.lines.build if @invoice.lines.blank?

    @last_invoice_number = Invoice.last.try(:number)

  end

  def auth
    @project = Project.find(params[:project_id])
    if !User.current.allowed_to?(:redmine_invoice_rate, @project)
      render_404
    end
  end

end

Ruby/redmine_invoice_rate/app/helpers/project_billings_helper.rb
module ProjectBillingsHelper

	def price_user_field id, value = 0
		field = "<input type='text' name='project_billing[#{id}]' value=#{value}>"
		field.html_safe
	end

end

Ruby/redmine_invoice_rate/app/helpers/project_invoice_helper.rb
module ProjectInvoiceHelper

  include RedmineInvoices::InvoiceReports
  include Redmine::I18n

  def collection_invoice_statuses_rate_plugin
    Invoice::STATUSES.map{|k, v| [l(v), k]}
  end

  def collection_invoice_statuses_for_select_rate_plugin
    collection_invoice_statuses_rate_plugin.select{|s| s[1] != Invoice::PAID_INVOICE}
  end

  def assignable_users
    collection_invoice_statuses_rate_plugin.select{|s| s[1] != Invoice::PAID_INVOICE}
  end

  def collection_for_discount_types_select_rate_plugin
    [:percent, :amount].each_with_index.collect{|l, index| [l("label_invoice_#{l.to_s}".to_sym), index]}
  end

  def invoice_lang_options_for_select_rate_plugin(has_blank=true)
    (has_blank ? [["(auto)", ""]] : []) +
        RedmineInvoices.available_locales.collect{|lang| [ ll(lang.to_s, :general_lang_name), lang.to_s]}.sort{|x,y| x.last <=> y.last }
  end

  def link_to_remove_invoice_fields_rate_plugin(name, f, options={})
    f.hidden_field(:_destroy) + link_to_function(name, "remove_invoice_fields(this)", options)
  end

  def link_to_add_invoice_fields_rate_plugin(name, f, association, options={})
    new_object = f.object.class.reflect_on_association(association).klass.new
    fields = f.fields_for(association, new_object, :child_index => "new_#{association}") do |builder|
      render(association.to_s.singularize + "_fields", :f => builder)
    end
    link_to_function(name, "add_invoice_fields(this, '#{association}', '#{escape_javascript(fields)}')", options={})
  end

end

Ruby/redmine_invoice_rate/app/views/context_menus/_invoice_issues.html.erb
<% if User.current.allowed_to?(:redmine_invoice_rate, @project) %>
  <% unless (@project = User.current.allowed_to?(:add_invoices, @project) ? @project : Invoice.allowed_target_projects.first).blank? %>

    <% if [0,1,2,3].include?(InvoicesSettings[:invoices_line_grouping, @project].to_i) %>
      <li><%= context_menu_link l(:button_invoice), {:controller => 'project_invoice',
                                                     :action => 'new',
                                                     :issues_ids => @issues.collect(&:id),
                                                     :project_id => @project,
                                                     :line_grouping => RedmineInvoices.settings[:invoices_line_grouping].to_i,
                                                     :back_url => @back},
                                :method => :get,
                                :class => 'icon-invoice-add-context' %>
      </li>
    <% else %>
      <li class="folder">
      	<a href="#" class="submenu icon-invoice-add-context"><%= l(:label_invoice_new) %></a>
      	<ul>
      	  <li><%= context_menu_link l(:label_invoice_line_grouping_by_activity), {:controller => 'project_invoice',
                                                         :action => 'new',
                                                         :issues_ids => @issues.collect(&:id),
                                                         :project_id => @project,
                                                         :line_grouping => 0,
                                                         :back_url => @back},
                                    :method => :get %>
          </li>
          <li><%= context_menu_link l(:label_invoice_line_grouping_by_issue), {:controller => 'project_invoice',
                                                         :action => 'new',
                                                         :issues_ids => @issues.collect(&:id),
                                                         :project_id => @project,
                                                         :line_grouping => 1,
                                                         :back_url => @back},
                                    :method => :get %>
          </li>
          <li><%= context_menu_link l(:label_invoice_line_grouping_by_user), {:controller => 'project_invoice',
                                                         :action => 'new',
                                                         :issues_ids => @issues.collect(&:id),
                                                         :project_id => @project,
                                                         :line_grouping => 2,
                                                         :back_url => @back},
                                    :method => :get %>
          </li>
          <li><%= context_menu_link l(:label_invoice_line_grouping_single_line), {:controller => 'project_invoice',
                                                         :action => 'new',
                                                         :issues_ids => @issues.collect(&:id),
                                                         :project_id => @project,
                                                         :line_grouping => 3,
                                                         :back_url => @back},
                                    :method => :get %>
          </li>
          <li><%= context_menu_link l(:label_invoice_line_grouping_by_time_entry), {:controller => 'project_invoice',
                                                         :action => 'new',
                                                         :issues_ids => @issues.collect(&:id),
                                                         :project_id => @project,
                                                         :line_grouping => 5,
                                                         :back_url => @back},
                                    :method => :get %>
          </li>
      	</ul>
      </li>
    <% end  %>
  <% end %>
<% end %>  

Ruby/redmine_invoice_rate/app/views/project_billings/_form.html.erb
<%= form_for(@project_billing) do |f| %>
  <%= hidden_field_tag :project_id, @project_billing.project.identifier %>
  
  <table>
    <thead>
      <th>Member</th>
      <th>Price of units</th>
    </thead>
    <tbody>
      <% @project_billing.project_user_prices.each do |billing_user| %>
      <tr>
        <td><%= link_to "#{billing_user.user.firstname} #{billing_user.user.lastname}", billing_user.user %></td>
        <td><%= price_user_field billing_user.user.id, billing_user.price %></td>
      </tr>
      <% end %>
    </tbody>
  </table>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

Ruby/redmine_invoice_rate/app/views/project_billings/edit.html.erb
<h1>Rates Edit</h1>

<%= render 'form' %>

Ruby/redmine_invoice_rate/app/views/project_billings/index.html.erb
<h1>Rates Listing</h1>
<% if @project_billings %>
<table>
  <thead>
    <th>Developer</th>
    <th>Rate</th>
  </thead>
  <tbody>
    <% @project_billings.project_user_prices.each do |billing_user| %>
    <tr>
      <td><%= link_to "#{billing_user.user.firstname} #{billing_user.user.lastname}", billing_user.user %></td>
      <td><%=  billing_user.price %></td>
    </tr>
    <% end %>
  </tbody>
</table>

<br>
<%= link_to 'Edit', edit_project_billing_path(@project_billings) %>
<% else %>
<%= link_to 'New', new_project_billing_path(:project_id => @project.identifier) %>

<% end %>

Ruby/redmine_invoice_rate/app/views/project_billings/new.html.erb
<h1>New Rates</h1>

<%= render 'form' %>

<%= link_to 'Back', project_billings_path %>

Ruby/redmine_invoice_rate/app/views/project_billings/show.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'Edit', edit_project_billing_path(@project_billing) %> |
<%= link_to 'Back', project_billings_path %>

Ruby/redmine_invoice_rate/app/views/project_invoice/_form.html.erb
<%= error_messages_for 'invoice' %>

<div class="box tabular attributes">

<div class="splitcontentleft">
  <p><%= f.text_field :number, :label => l(:field_invoice_number), :required => true, :style => "width: 90%" %>
    <% if invoice.new_record? && @last_invoice_number %>
    <br>
  	<em class="info"><%= l(:label_invoice_last_number, :number => @last_invoice_number) %></em>
  	<% end %>
  </p>

  <p class="subject"><%= f.text_field :subject, :label => l(:field_invoice_subject), :style => "width: 90%" %></p>
  <p><%= f.select :project_id, project_tree_options_for_select(Invoice.allowed_target_projects, :selected => @project), {:required => true} %></p>
  <p class="object-select">
    <% if !invoice.new_record? && invoice.is_paid? %>
      <%= label_tag l(:field_invoice_status) %><%= invoice.status %>
    <% else %>
      <%= f.select :status_id, collection_invoice_statuses_for_select_rate_plugin, :label => l(:field_invoice_status), :required => true %>
    <% end %>
  </p>
  <p class="object-select">
    <%= label_tag :invoice_contact_id,  l(:field_invoice_contact)%>
    <%= select_contact_tag('invoice[contact_id]', invoice.contact, :is_select => Contact.visible.by_project(RedmineInvoices.settings[:invoices_cross_project_contacts] ? nil : @project).count < 50, :cross_project_contacts => RedmineInvoices.settings[:invoices_cross_project_contacts], :is_company => RedmineInvoices.settings[:invoices_select_companies], :include_blank => true, :add_contact => true, :display_field => invoice.contact.blank?) %>
  </p>
  <p class="object-select"><%= f.select :assigned_to_id, (@project.assignable_users.collect {|m| [m.name, m.id]}), :include_blank => true, :label => l(:field_assigned_to) %></p>
</div>

<div class="splitcontentright">
  <p><%= f.text_field :order_number, :label => l(:field_invoice_order_number) %> </p>
  <p><%= f.text_field :invoice_date, :size => 12, :required => true %><%= calendar_for('invoice_invoice_date') %> </p>
  <p><%= f.text_field :due_date, :label => l(:field_invoice_due_date), :size => 12 %><%= calendar_for('invoice_due_date') %> </p>
  <p><%= f.select :currency, collection_for_currencies_select, :label => l(:field_invoice_currency), :include_blank => true  %></p>
  <p>
    <%= f.text_field :discount, :label => l(:field_invoice_discount), :size => 10 %>
    <%= f.select :discount_type, collection_for_discount_types_select_rate_plugin, {:no_label => true}, :style => "width: 55px;" %>
  </p>
  <p class="object-select"><%= f.select :language, invoice_lang_options_for_select_rate_plugin, {:label => l(:field_invoice_language)}, :disabled => InvoicesSettings.is_custom_template?(@project)  %></p>

</div>

<div style="clear:both;"> </div>

<p><%= f.text_area :description, :cols => 60, :rows => 10, :class => 'wiki-edit' %><%= wikitoolbar_for 'invoice_description' %></p>

<fieldset class="attributes">
  <legend><%= l(:label_invoice_lines) %></legend>
  <table class="invoice-lines form">
    <tr>
      <!-- <th class="sort"></th> -->
      <th><%= l(:field_invoice_line_description) %></th>
      <th><%= l(:field_invoice_line_quantity) %></th>
      <% if InvoicesSettings.show_units? %>
      <th><%= l(:field_invoice_line_units) %></th>
      <% end %>
      <th><%= l(:field_invoice_line_price) %></th>
      <% if !InvoicesSettings.disable_taxes?(@project) || invoice.has_taxes?  %>
      <th><%= l(:field_invoice_line_tax) %></th>
      <% end %>
      <th><%= l(:label_invoice_total) %></th>
    </tr>

    <tbody id="sortable">
      <tr style="display:none;"></tr>
      <%= f.fields_for :lines do |builder| %>
          <%= render :partial => 'line_fields', :locals => {:f => builder, :invoice => invoice} %>
      <% end %>
    </tbody>
    <tr class="line-total">
      <td style="text-align: left;" class="add-link" colspan="<%= 3 + (InvoicesSettings.show_units? ? 1 : 0) + (!InvoicesSettings.disable_taxes?(@project) || invoice.has_taxes?  ? 1 : 0)  %>">
      <%= link_to_add_invoice_fields_rate_plugin l(:label_invoice_add_line), f, :lines %>
      <%= call_hook(:edit_invoices_form_lines_actions, { :invoice => invoice, :form => f }) %>
      </td>
      <td class="total-data total" id="total_amount"><%= "%.2f" % invoice.amount.to_f %></td>
      <td class="total-data"></td>
    </tr>
  </table>

</fieldset>

</div>

Ruby/redmine_invoice_rate/app/views/project_invoice/_line_fields.html.erb
<tr class="line fields sortable-line" id="line-<%= f.object.id %>">
  <!-- <td><span class="sort icon icon-sort" style="cursor: row-resize;"></span> </td>  -->
  <td class="description"><%= f.text_area :description, :no_label => true,  :rows => f.object.description.blank? ? 2 : [f.object.description.lines.count, 2].max, :onkeyup => "activateTextAreaResize(this);" %></td>
  <td class="quantity"><%= f.text_field :quantity, :no_label => true, :size => 6, :onkeyup => 'updateInvoiceTotal(this)' %></td>
  <% if InvoicesSettings.show_units? %>
  <td class="units"><%= f.text_field :units, :no_label => true, :size => 8 %></td>
  <% end %>
  <td class="price"><%= f.text_field :price, :no_label => true, :size => 8, :onkeyup => 'updateInvoiceTotal(this)' %></td>
  <% if !InvoicesSettings.disable_taxes?(@project) || (f.object.invoice.respond_to?(:has_taxes?) && f.object.invoice.has_taxes?)   %>
  <td class="tax">
    <% line_tax = (f.object.new_record? && f.object.tax.blank?) ? ContactsSetting.default_tax : f.object.tax %>
    <%= check_box_tag :show_tax, "1", false, :onclick=>"$(this).hide(); $(this).parent().find('.tax-fields').show(); $(this).next().find('input').focus();  $(this).next().find('input').val('#{ContactsSetting.default_tax}'); return false;" if line_tax.blank? || line_tax == 0 %>
    <span class="tax-fields" style="white-space: nowrap; <%= line_tax.blank? || line_tax == 0 ? "display:none;" : "" %>"><%= f.text_field :tax, :no_label => true, :size => 5, :value => line_tax %>&nbsp;%
    </span>
  </td>
  <% end %>
  <td class="total"><%= format("%.2f\n", f.object.price * f.object.quantity) if f.object.price && f.object.quantity  %></td>
  <td> <%= link_to_remove_invoice_fields_rate_plugin "", f, :class => "icon icon-del"  %></td>
  <%= f.hidden_field :position, :class => 'position' %>
</tr>

Ruby/redmine_invoice_rate/app/views/project_invoice/new.html.erb
<h2><%= l(:label_invoice_new) %></h2>

<%= labelled_form_for :invoice, @invoice, :url => {:controller => 'invoices',:action => 'create', :project_id => @project}, :html => { :multipart => true, :id => 'invoice_form'} do |f|  %>
  <%= render :partial => 'form', :locals => {:f => f, :invoice => @invoice}  %>
  <%= submit_tag l(:button_save) -%>
<% end -%>

<% content_for :header_tags do %>
  <%= javascript_include_tag :invoices, :plugin => 'redmine_contacts_invoices'  %>
<% end %>